/*
* Copyright (C) 2022 Texas Instruments Incorporated - http://www.ti.com/
*
*
*  Redistribution and use in source and binary forms, with or without
*  modification, are permitted provided that the following conditions
*  are met:
*
*    Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/
import QtQuick 2.0

Rectangle {
    id: digitItem
    width: size
    height: size

    clip: true

    gradient: Gradient {
        GradientStop {
            position: 0.0
            color: "black"
        }

        GradientStop {
            position: 0.5
            color: "#222222"
        }

        GradientStop {
            position: 1.0
            color: "black"
        }
    }

    property color borderColor: "black"
    property int borderWidth: 1
    border.color: borderColor
    border.width: borderWidth

    property int digit: 0
    property int size: 80


    onDigitChanged: { digitPath.currentIndex = digit; }

    PathView {
        id: digitPath
        objectName: "digitPathObj"

        width: digitItem.size
        height: digitItem.size * 10

        anchors.centerIn: parent

        model: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

        delegate: Text {
            width: digitItem.size
            height: digitItem.size

            text: modelData;

            color: "white";

            horizontalAlignment: Text.AlignHCenter;
            verticalAlignment: Text.AlignVCenter;

            font.pointSize: digitItem.size-4;
        }

        preferredHighlightBegin: 0.5
        preferredHighlightEnd: 0.5

        path: Path {
            startX: digitPath.width / 2
            startY: 0 + size *.1

            PathLine { x: digitPath.width / 2; y: digitPath.height }
        }
    }
}
